#include <stdio.h>
#include <map>
#include <string.h>

using namespace std;

struct strCmp {
  bool operator()( const char* s1, const char* s2 ) const {
    return strcmp( s1, s2 ) < 0;
  }
};


map<const char*, int, strCmp> neprestupny;
map<const char*, int, strCmp> prestupny;
int zacinajiDnem[3010];
int neprestupneDny[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
int prestupneDny[] = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

char s[50];
char r[2000];
int y;
int dny[400];

bool prestupny;

int getIndex(char * den) {
	return prestupny ? prestupny[den] : neprestupny[den];
}

void zaskrtniDny(int index, int dni) {
	int i = zacinajiDnem[y] == 7 ? 0 : zacinajiDnem[y];
	while(i < dni) {
		dny[i] = 1; 
		i+=7;
	}
}

int tdny[300]
int tdnycount = 0;

void filltdny(int dni) {
	tdnycount = 0;
	int i = zacinajiDnem[y] == 7 ? 0 : zacinajiDnem[y];
	while(i < dni) {
		tdny[tdnycount] = i; 
		i+=7;
		tdnycount++;
	}
	tdny[tdnycount++] = getIndex("1.1.");
	tdny[tdnycount++] = getIndex("8.5.");
	tdny[tdnycount++] = getIndex("5.7.");
	tdny[tdnycount++] = getIndex("6.7.");
	tdny[tdnycount++] = getIndex("28.9.");
	tdny[tdnycount++] = getIndex("28.10.");
	tdny[tdnycount++] = getIndex("17.11.");
	tdny[tdnycount++] = getIndex("24.12.");
	tdny[tdnycount++] = getIndex("25.12.");
	tdny[tdnycount++] = getIndex("26.12.");

	int golden, solar, lunar, p;
	golden = (y%19) + 1;
	solar = (y-1600) / 100 - (y-1600) / 400;
	lunar = (((y-1400)/100)*8)/25;
	p = (3003-(11*golden)+solar-lunar)%30;
	if(p==29 ||(p==28 && golden > 11)) p--;

	int pfm = getIndex("21.3.") + p;
	int zacina = (zacinajiDnem[y] + pfm) % 7;
	zacina++;
	pfm++;
	while(zacina != 7) {
		zacina++;
		pfm++;
	}
	pfm++;
	
	tdny[tdnycount++] = pfm;
}

void zaskrtnit(int dni) {
	filltdny(dni);
	for(int i = 0; i < tdnycount; i++)
		dny[tdny[i]] = 1;
}
void zakrtniw(int dni) {
	
}


int line() {
	for(int i = 0; i < 400; i++)
		dny[i] = 0;
	int ok = scanf("%s %s %d", s, r, &y);
	if(ok != 3)
		return 0;
	prestupny = (y%4==0 && y%100!=0) || y%400==0;
	int dni = prestupny ? 366 : 365;
	int lens = strlen(s);
	for(int i = 0; i < lens; i++) {
		switch(s[i]) {
			case '1': zaskrtniDny(1, dni); break;
			case '2': zaskrtniDny(2, dni); break;
			case '3': zaskrtniDny(3, dni); break;
			case '4': zaskrtniDny(4, dni); break;
			case '5': zaskrtniDny(5, dni); break;
			case '6': zaskrtniDny(6, dni); break;
			case '7': zaskrtniDny(7, dni); break;
			case 't': zaskrtnit(dni); break;

		}
	}

	return 1;
}

int main() {
	int index = 0; // index od 0 !!!
	for(int mesic = 0; mesic < 12; mesic++) {
		for(int den = 0; den < neprestupneDny[mesic]; den++) {
			char * text = new char[10];
			sprintf(text, "%d.%d.", den+1, mesic+1);
			neprestupny[text] = index;
			index++;
		}
	}
	index = 0;
	for(int mesic = 0; mesic < 12; mesic++) {
		for(int den = 0; den < prestupneDny[mesic]; den++) {
			char * text = new char[10];
			sprintf(text, "%d.%d.", den+1, mesic+1);
			prestupny[text] = index;
			index++;
		}
	}
// 1.1.2000 = 7
// prestupny + 2 jinak + 1
	zacinajiDnem[2000] = 6;
	for(int i = 2001; i < 3007; i++) {
		bool prestupny = ((i-1)%4==0 && (i-1)%100!=0) || (i-1)%400==0;
		zacinajiDnem[i] = (((prestupny) ? zacinajiDnem[i-1]+2 : zacinajiDnem[i-1]+1)%7);
		zacinajiDnem[i] = zacinajiDnem[i] == 0 ? 7 : zacinajiDnem[i];
		//printf("%d %d %d .... ", i, zacinajiDnem[i], (int)prestupny);
	} 
	for(int i = 2000; i > 1550; i--) {
		bool prestupny = ((i)%4==0 && (i)%100!=0) || (i)%400==0;
		zacinajiDnem[i] = ((((prestupny) ? zacinajiDnem[i+1]-2 : zacinajiDnem[i+1]-1)));
		if(zacinajiDnem[i] < 1)
			zacinajiDnem[i]	=zacinajiDnem[i]+7;
//		zacinajiDnem[i] = 7 - zacinajiDnem[i];
//		printf("%d %d %d .... ", i, zacinajiDnem[i], (int)prestupny);
	} 

	while(line());	

	return 0;
}
